/*
 * Vifir - An electronic flight bag wannabe utility for aircraft pilots
 * Copyright (C) 2009 David Ludlow
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * dave@adsllc.com, PO Box 13070, Toledo, OH 43623
 */

#ifndef CONFIGDIALOG_H_
#define CONFIGDIALOG_H_

#include <gtkmm/dialog.h>
#include <gtkmm/button.h>
#include <gtkmm/label.h>
#include <gtkmm/checkbutton.h>
#include <gtkmm/radiobutton.h>
#include <gtkmm/spinbutton.h>
#include <gtkmm/combobox.h>
#include <gtkmm/spinbutton.h>
#include <gtkmm/entry.h>
#include <libglademm.h>

#include "Config.h"

class ConfigDialog
{
public:
	ConfigDialog(std::string *GladeFilename, Config *Cfg);
	~ConfigDialog();
	int Run();

private:
	Config *Cfg;

	Glib::RefPtr<Gnome::Glade::Xml> refXml;
	Gtk::Dialog *GtkDialog;
	Gtk::CheckButton SaveConfigOnExitCheckbox;
	Gtk::Button *SaveNow;
	Gtk::Button *LoadNow;

	Gtk::RadioButton *gpsd;
	Gtk::Entry *gpsdHost;
	Gtk::Entry *gpsdPort;
	Gtk::RadioButton *SerialPort;
	Gtk::RadioButton *Simulated;
	Gtk::Entry *SerialPortDevice;
	Gtk::ComboBox *SerialPortBaud;
	Gtk::CheckButton *AutoActivateGPS;
	Gtk::CheckButton *AutoStartgpsd;
	Gtk::CheckButton *AutoSelectChart;
	Gtk::Entry *PDFViewer;
	Gtk::Entry *ImageViewer;
	Gtk::CheckButton *SaveConfigOnExit;
	Gtk::Entry *UserDataDir;
	Gtk::Entry *DataStoreDir;
	Gtk::Entry *METARSourceURL;
	Gtk::CheckButton *CenterChartOnGPS;
	Gtk::Entry *gpsdCmd;
	Gtk::SpinButton *GPSUpdateFrequency;
	Gtk::Entry *NationalFlightDBImportDir;
	Gtk::Entry *XPlane900DataImportDir;
	Gtk::Entry *SectionalsImportDir;
	Gtk::Entry *dTPPImportDir;
	Gtk::Entry *DigitalAeroInfoImportDir;
	Gtk::Label *DAILabel;
	Gtk::SpinButton *SimLon;
	Gtk::SpinButton *SimLat;
	Gtk::SpinButton *SimTrk;
	Gtk::SpinButton *SimSpd;
	Gtk::SpinButton *SimAlt;
	Gtk::CheckButton *DisableSS;
	Gtk::CheckButton *DisablePM;
	Gtk::CheckButton *ShowWelcomeOnStartupCheckbox;

	void SetConfig();
	void GetConfig();
	void on_OKButton_activate();

	void on_SaveNow_clicked();
	void on_LoadNow_clicked();
};

#endif /*CONFIGDIALOG_H_*/
