/*
 * Vifir - An electronic flight bag wannabe utility for aircraft pilots
 * Copyright (C) 2009 David Ludlow
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * dave@adsllc.com, PO Box 13070, Toledo, OH 43623
 */

#ifndef IMPORTSECTIONALSDVD_H_
#define IMPORTSECTIONALSDVD_H_

#include <string>
#include <gtkmm/window.h>
#include <gtkmm/progressbar.h>
#include <gtkmm/button.h>
#include <libglademm.h>
#include "Config.h"
#include "DataStore.h"
#include "OverwriteFileDialog.h"
#include "GeoChart.h"

class ImportSectionalsDVD
{
public:
	ImportSectionalsDVD(Config *Cfg, std::string *GladeFilename, DataStore *Data);
	~ImportSectionalsDVD();

	int Run();
	void on_CancelButton_clicked();

	void ImportCharts(std::string SrcDir, std::string DstDir, GeoChart::Type_enum Type);

private:
	static const double SectionalsProgressFrac=0.6;
	static const double TACsProgressFrac=0.2;
	static const double FlywaysProgressFrac=0.2;

	Config *Cfg;
	std::string *GladeFilename;
	DataStore *Data;
	Volume *VolData;

	Glib::RefPtr<Gnome::Glade::Xml> refXml;
	Gtk::Window *ProgressWindow;
	Gtk::ProgressBar *ProgressBar,*SubProgressBar;
	Gtk::Button *CancelButton;
	bool CancelFlag;
	double ProgressDone;
	OverwriteFileDialog *OFDialog;
};

#endif /*IMPORTSECTIONALSDVD_H_*/
